﻿Imports Infragistics.Win

Public Class Form1
    Implements Infragistics.Win.IUIElementCreationFilter
    Dim btn As ButtonUIElement
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.UltraTabControl1.CreationFilter = Me
    End Sub

    Private Sub UltraTabControl1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles UltraTabControl1.KeyDown
        If e.Alt And e.KeyCode = Keys.B Then
            Try

                Dim arg As New UIElementEventArgs(btn)
                Call btn_Click(btn, arg)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
    End Sub

    Public Sub AfterCreateChildElements(ByVal parent As Infragistics.Win.UIElement) Implements Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements
        Dim tabRowUIElement As Infragistics.Win.UltraWinTabs.TabRowUIElement

        If TypeOf parent Is Infragistics.Win.UltraWinTabs.TabRowUIElement Then
            tabRowUIElement = CType(parent, Infragistics.Win.UltraWinTabs.TabRowUIElement)

            btn = New ButtonUIElement(parent)
            AddHandler btn.ElementClick, AddressOf btn_Click
            btn.Rect = New Rectangle(New Point(parent.Rect.Right - 20, btn.Rect.Y), New Size(20, 20))
            parent.ChildElements.Add(btn)

        End If

    End Sub

    Private Sub btn_Click(ByVal sender As Object, ByVal e As UIElementEventArgs)
        MessageBox.Show("Clicked")
    End Sub

    Public Function BeforeCreateChildElements(ByVal parent As Infragistics.Win.UIElement) As Boolean Implements Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements
        Return False
    End Function

End Class
